******************************
* Program TD_BAR
* From T.D.
* Produce Code 3 of 9 barcodes
*
* Original Author
*  Bill Wood
*  Milwaukee, WI
* Revised (written in Clipper)
*  George T. Neill
*  2140 Main St
*  La Crosse, WI 54601
* Revised (written in Foxbase)
*  T.D.
*  Tim Chiaretto
*  Gradena, CA 90247
*  CIS 70371,253
*  BBS 213 217-8919
*  *******************************
* Copyright.: None, released to the public domain as is with no express
*             or implied warranty as to suitability or accuracy of this
*             program.  The author shall not be held liable for any 
*             damages, either direct or non-direct, arising from the use
*             of this program.  This program may be modified and/or
*             included in any program without any consideration to the
*             author.
**************************************************************************
*****                 CODE 3-of-9 BAR CODE  GENERATOR                *****
*****                 *******************************                *****
*****      This program will generate standard 3-of-9 bar code       *****
*****                      on an HP Laserjet II.                     *****
*****                 ******************************                 *****
*****                      -  SPECIFICATIONS -                       *****
**                                                                      **
**                         W                                 N          **
**                |  Nominal Width  | Nominal Width  | Nominal Ratio    **
**     Density    |       of        |      of        |      of          **
**   (Characters/ | Narrow Bars and | Wide Bars and  | Wide to Narrow   **
**      Inch)     | Spaces (Inches) | Spaces (Inches)| Element Width    **
**   -------------+-----------------+----------------+----------------  **
**      5.730     |     0.0125      |     0.0315     |      2.52        **
**   -------------+-----------------+----------------+----------------  **
**                                                                      **
*****                 ******************************                 *****

* Vpos and Hpos are the location for printing
* Message is the data to print
* Nbar is the narrow bar of the barcode
* Wbar is the wide bar
* Nspc is the narrow space
* Wspc is the wide space
* Code is barcodeed output to the printer

PARAMETERS Vpos,Hpos,Message
PRIVATE Nbar,Wbar,Nspc,Wspc,Code 
STORE " " TO Nbar,Wbar,Nspc,Wspc,Code
Esc = CHR(27)
Null = ""
Height    = 3  && Number of lines high trhe barcode will be

*** define bars and spaces for HP LaserJet II
Small_bar = 4                                 && number of points per bar
Wide_bar = round(small_bar * 2.25,0)          && 2.25 x small_bar
Dpl = 50                                      && dots per line 300dpi/6lpi = 50dpl

Nbar = esc+"*c"+transform(small_bar,'99')+"a"+rtrim(ltrim(str(height*dpl)))+"b0P"+esc+"*p+"+transform(small_bar,'99')+"X"
Wbar = esc+"*c"+transform(wide_bar,'99')+"a"+rtrim(ltrim(str(height*dpl)))+"b0P"+esc+"*p+"+transform(wide_bar,'99')+"X"
Nspc = esc+"*p+"+transform(small_bar,'99')+"X"
Wspc = esc+"*p+"+transform(wide_bar,'99')+"X"

Start = Nbar+Wspc+Nbar+Nspc+Wbar+Nspc+Wbar+Nspc+Nbar+Nspc  && Start code required
End = Nspc+Nbar+Wspc+Nbar+Nspc+Wbar+Nspc+Wbar+Nspc+Nbar    && Stop code required

***** Define CODE 3of9 Characer Set *****  
DO TD_BARS

Message = TRIM(Message)

***** print barcoded Message *****
Code = ""

* read message character at a time and build barcode
Counter=1
@ Vpos,Hpos SAY Start+Esc+"&f0S"
DO WHILE Counter<=len(Message)
	Letter = SUBSTR(Message,Counter,1)
	Code = Char(AT(Letter,Chars)) + Nspc
	@ PROW(),PCOL() SAY Esc+"&f1S"+Code+Esc+"&f0S"
	Counter=Counter+1
ENDDO
@ PROW(),PCOL() SAY Esc+"&f1S"+End

RETURN

